#pragma once

#include "flexpage.h"

/* A file accessor, providing flexpages corresponding to file regions. */

class Accessor
{
protected:
    offset_t _size;

    /* Data transfer helper methods. */

    virtual void fill_populated(Flexpage *flexpage);

    virtual void flush_populated(Flexpage *flexpage);

public:
    fileid_t fileid;

    explicit Accessor(fileid_t fileid, offset_t size=0);

    virtual offset_t get_size();

    virtual void set_size(offset_t size);

    virtual void close();

    virtual void open();

    /* Data transfer methods. */

    virtual void fill(Flexpage *flexpage);

    virtual void flush(Flexpage *flexpage);
};

// vim: tabstop=4 expandtab shiftwidth=4
